# Mímalo

A library to get the Mime Types from Extensions and the Extensions from Mime types

Hecho en 🇵🇷 por Radamés J. Valentín Reyes

# Import

~~~dart
import 'package:mimalo/mimalo.dart';
~~~

# Examples

## mimalo

A function to get the mime type of the file by supplying the file path or extension as String

~~~dart
String? type = mimalo(filePathOrExtension: "nada.js");
~~~

## noMeMimes

A function to get the extension of the file by supplying the mime type

~~~dart
String? fileExtension = noMeMimes(
  mimeType: "application/javascript",
);
if(fileExtension != null){
  print(fileExtension);
}
~~~

# For node.js users

A software similar to this(the original library/package) that I wrote a couple of years ago

https://www.npmjs.com/package/mimalo

# JS code used to extract mime types from the MDN website

Ran this code on the developer console while on the MDN website on MIME Types. It was not a perfect solution but only required minimal modification. Just copied the code logged into the console.
~~~js
var rows = document.getElementById("mimes").getElementsByTagName("tr");
var result = "";
for(rowIndex = 0; rowIndex < rows.length; rowIndex++){
  var thisRow = rows.item(rowIndex);
  var thisColumns = thisRow.getElementsByTagName("td");
  //Extensions are in the first column
  var extensions = thisColumns[0].getElementsByTagName("code");
  var mimeType = thisColumns[2].getElementsByTagName("code")[0].textContent;
  for(extensionIndex = 0; extensionIndex < extensions.length; extensionIndex++){
    var thisExtension = extensions[extensionIndex].textContent;
    result += '"'+ thisExtension +'" : "' + mimeType + '",\n';
  }
}
console.log(result);
~~~
------------------------------------------------------------
## Contribute/donate by tapping on the Pay Pal logo/image

<a href="https://www.paypal.com/paypalme/onlinespawn"><img src="https://www.paypalobjects.com/webstatic/mktg/logo/pp_cc_mark_74x46.jpg"/></a>

------------------------------------------------------------

## Created by

<a href="https://www.facebook.com/rawwaresoftware"><img src="https://by3302files.storage.live.com/y4mq-KE-LI1AbiPqmHCa9SjPsg3FwP4YIq0gCVjumTSJRS7KCvni50xCSYEujSjLQCcVcc32pJBAzeghTvS7HkIwEh65abnZwRi_jduImV84F9Te1rAdCQ-FNjhCJlp0rkF83OqFmXq7fygxutbvL6EV9Q02iRvA_awnR2sSxjfFi3OKb2Q-RlIAtLqRl22JZ3h?width=820&height=312&cropmode=none" width="300px"></a>

------------------------------------------------------------

# References
- https://developer.mozilla.org/es/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Common_types
- https://api.dart.dev/stable/2.14.4/dart-io/ContentType/text.html